import{s as ze,n as Ie,o as Ve}from"../chunks/scheduler.defa9a21.js";import{S as Ae,i as Oe,g as i,s as n,r as d,A as Re,h as s,f as t,c as l,j as y,u as m,x as S,k as w,y as r,a as o,v as p,d as f,t as _,w as g}from"../chunks/index.fe795e71.js";import{D as A}from"../chunks/Docstring.170994c1.js";import{H as Y,E as We}from"../chunks/EditOnGithub.0f575778.js";function Ge(Te){let $,Z,Q,ee,F,te,T,ae,b,C,he,O,Ce="Enables RAM efficient loading of Hugging Face models for FSDP in the environment.",ne,N,le,v,k,$e,R,Ne="Disables RAM efficient loading of Hugging Face models for FSDP in the environment.",re,E,ie,u,L,be,W,ke=`Merge the weights from sharded FSDP model checkpoints into a single combined checkpoint. Should be used if
<code>SHARDED_STATE_DICT</code> was used for the model. Weights will be saved to <code>{output_path}/model.safetensors</code> if
<code>safe_serialization</code> else <code>pytorch_model.bin</code>.`,ve,G,Ee="Note: this is a CPU-bound process.",se,H,oe,c,M,ye,j,Le="This plugin is used to enable fully sharded data parallelism.",we,x,U,xe,q,He=`Given <code>model</code>, creates an <code>auto_wrap_policy</code> baesd on the passed in policy and if we can use the
<code>transformer_cls_to_wrap</code>`,Pe,P,z,De,B,Me="Sets the mixed precision policy for FSDP",Se,D,I,Fe,J,Ue="Set the state dict config based on the <code>StateDictType</code>.",ce,V,de,X,me;return F=new Y({props:{title:"Fully Sharded Data Parallel utilities",local:"fully-sharded-data-parallel-utilities",headingTag:"h1"}}),T=new Y({props:{title:"enable_fsdp_ram_efficient_loading",local:"accelerate.utils.enable_fsdp_ram_efficient_loading",headingTag:"h2"}}),C=new A({props:{name:"accelerate.utils.enable_fsdp_ram_efficient_loading",anchor:"accelerate.utils.enable_fsdp_ram_efficient_loading",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/fsdp_utils.py#L30"}}),N=new Y({props:{title:"disable_fsdp_ram_efficient_loading",local:"accelerate.utils.disable_fsdp_ram_efficient_loading",headingTag:"h2"}}),k=new A({props:{name:"accelerate.utils.disable_fsdp_ram_efficient_loading",anchor:"accelerate.utils.disable_fsdp_ram_efficient_loading",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/fsdp_utils.py#L40"}}),E=new Y({props:{title:"merge_fsdp_weights",local:"accelerate.utils.merge_fsdp_weights",headingTag:"h2"}}),L=new A({props:{name:"accelerate.utils.merge_fsdp_weights",anchor:"accelerate.utils.merge_fsdp_weights",parameters:[{name:"checkpoint_dir",val:": str"},{name:"output_path",val:": str"},{name:"safe_serialization",val:": bool = True"},{name:"remove_checkpoint_dir",val:": bool = False"}],parametersDescription:[{anchor:"accelerate.utils.merge_fsdp_weights.checkpoint_dir",description:`<strong>checkpoint_dir</strong> (<code>str</code>) &#x2014;
The directory containing the FSDP checkpoints (can be either the model or optimizer).`,name:"checkpoint_dir"},{anchor:"accelerate.utils.merge_fsdp_weights.output_path",description:`<strong>output_path</strong> (<code>str</code>) &#x2014;
The path to save the merged checkpoint.`,name:"output_path"},{anchor:"accelerate.utils.merge_fsdp_weights.safe_serialization",description:`<strong>safe_serialization</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to save the merged weights with safetensors (recommended).`,name:"safe_serialization"},{anchor:"accelerate.utils.merge_fsdp_weights.remove_checkpoint_dir",description:`<strong>remove_checkpoint_dir</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to remove the checkpoint directory after merging.`,name:"remove_checkpoint_dir"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/fsdp_utils.py#L274"}}),H=new Y({props:{title:"FullyShardedDataParallelPlugin",local:"accelerate.FullyShardedDataParallelPlugin",headingTag:"h2"}}),M=new A({props:{name:"class accelerate.FullyShardedDataParallelPlugin",anchor:"accelerate.FullyShardedDataParallelPlugin",parameters:[{name:"sharding_strategy",val:": Union = None"},{name:"backward_prefetch",val:": Union = None"},{name:"mixed_precision_policy",val:": Union = None"},{name:"auto_wrap_policy",val:": Union = None"},{name:"cpu_offload",val:": Union = None"},{name:"ignored_modules",val:": Optional = None"},{name:"state_dict_type",val:": Union = None"},{name:"state_dict_config",val:": Union = None"},{name:"optim_state_dict_config",val:": Union = None"},{name:"limit_all_gathers",val:": bool = True"},{name:"use_orig_params",val:": bool = None"},{name:"param_init_fn",val:": Optional = None"},{name:"sync_module_states",val:": bool = None"},{name:"forward_prefetch",val:": bool = None"},{name:"activation_checkpointing",val:": bool = None"},{name:"cpu_ram_efficient_loading",val:": bool = None"},{name:"transformer_cls_names_to_wrap",val:": Optional = None"},{name:"min_num_params",val:": Optional = None"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/dataclasses.py#L1316"}}),U=new A({props:{name:"set_auto_wrap_policy",anchor:"accelerate.FullyShardedDataParallelPlugin.set_auto_wrap_policy",parameters:[{name:"model",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/dataclasses.py#L1594"}}),z=new A({props:{name:"set_mixed_precision",anchor:"accelerate.FullyShardedDataParallelPlugin.set_mixed_precision",parameters:[{name:"mixed_precision",val:""},{name:"buffer_autocast",val:" = False"},{name:"override",val:" = False"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/dataclasses.py#L1625"}}),I=new A({props:{name:"set_state_dict_type",anchor:"accelerate.FullyShardedDataParallelPlugin.set_state_dict_type",parameters:[{name:"state_dict_type",val:" = None"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/dataclasses.py#L1558"}}),V=new We({props:{source:"https://github.com/huggingface/accelerate/blob/main/docs/source/package_reference/fsdp.md"}}),{c(){$=i("meta"),Z=n(),Q=i("p"),ee=n(),d(F.$$.fragment),te=n(),d(T.$$.fragment),ae=n(),b=i("div"),d(C.$$.fragment),he=n(),O=i("p"),O.textContent=Ce,ne=n(),d(N.$$.fragment),le=n(),v=i("div"),d(k.$$.fragment),$e=n(),R=i("p"),R.textContent=Ne,re=n(),d(E.$$.fragment),ie=n(),u=i("div"),d(L.$$.fragment),be=n(),W=i("p"),W.innerHTML=ke,ve=n(),G=i("p"),G.textContent=Ee,se=n(),d(H.$$.fragment),oe=n(),c=i("div"),d(M.$$.fragment),ye=n(),j=i("p"),j.textContent=Le,we=n(),x=i("div"),d(U.$$.fragment),xe=n(),q=i("p"),q.innerHTML=He,Pe=n(),P=i("div"),d(z.$$.fragment),De=n(),B=i("p"),B.textContent=Me,Se=n(),D=i("div"),d(I.$$.fragment),Fe=n(),J=i("p"),J.innerHTML=Ue,ce=n(),d(V.$$.fragment),de=n(),X=i("p"),this.h()},l(e){const a=Re("svelte-u9bgzb",document.head);$=s(a,"META",{name:!0,content:!0}),a.forEach(t),Z=l(e),Q=s(e,"P",{}),y(Q).forEach(t),ee=l(e),m(F.$$.fragment,e),te=l(e),m(T.$$.fragment,e),ae=l(e),b=s(e,"DIV",{class:!0});var pe=y(b);m(C.$$.fragment,pe),he=l(pe),O=s(pe,"P",{"data-svelte-h":!0}),S(O)!=="svelte-1lsbcnp"&&(O.textContent=Ce),pe.forEach(t),ne=l(e),m(N.$$.fragment,e),le=l(e),v=s(e,"DIV",{class:!0});var fe=y(v);m(k.$$.fragment,fe),$e=l(fe),R=s(fe,"P",{"data-svelte-h":!0}),S(R)!=="svelte-o9zxg8"&&(R.textContent=Ne),fe.forEach(t),re=l(e),m(E.$$.fragment,e),ie=l(e),u=s(e,"DIV",{class:!0});var K=y(u);m(L.$$.fragment,K),be=l(K),W=s(K,"P",{"data-svelte-h":!0}),S(W)!=="svelte-lbcivn"&&(W.innerHTML=ke),ve=l(K),G=s(K,"P",{"data-svelte-h":!0}),S(G)!=="svelte-s693kt"&&(G.textContent=Ee),K.forEach(t),se=l(e),m(H.$$.fragment,e),oe=l(e),c=s(e,"DIV",{class:!0});var h=y(c);m(M.$$.fragment,h),ye=l(h),j=s(h,"P",{"data-svelte-h":!0}),S(j)!=="svelte-da89af"&&(j.textContent=Le),we=l(h),x=s(h,"DIV",{class:!0});var _e=y(x);m(U.$$.fragment,_e),xe=l(_e),q=s(_e,"P",{"data-svelte-h":!0}),S(q)!=="svelte-i24l23"&&(q.innerHTML=He),_e.forEach(t),Pe=l(h),P=s(h,"DIV",{class:!0});var ge=y(P);m(z.$$.fragment,ge),De=l(ge),B=s(ge,"P",{"data-svelte-h":!0}),S(B)!=="svelte-1oofbyv"&&(B.textContent=Me),ge.forEach(t),Se=l(h),D=s(h,"DIV",{class:!0});var ue=y(D);m(I.$$.fragment,ue),Fe=l(ue),J=s(ue,"P",{"data-svelte-h":!0}),S(J)!=="svelte-1ugzx3"&&(J.innerHTML=Ue),ue.forEach(t),h.forEach(t),ce=l(e),m(V.$$.fragment,e),de=l(e),X=s(e,"P",{}),y(X).forEach(t),this.h()},h(){w($,"name","hf:doc:metadata"),w($,"content",je),w(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(u,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(c,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,a){r(document.head,$),o(e,Z,a),o(e,Q,a),o(e,ee,a),p(F,e,a),o(e,te,a),p(T,e,a),o(e,ae,a),o(e,b,a),p(C,b,null),r(b,he),r(b,O),o(e,ne,a),p(N,e,a),o(e,le,a),o(e,v,a),p(k,v,null),r(v,$e),r(v,R),o(e,re,a),p(E,e,a),o(e,ie,a),o(e,u,a),p(L,u,null),r(u,be),r(u,W),r(u,ve),r(u,G),o(e,se,a),p(H,e,a),o(e,oe,a),o(e,c,a),p(M,c,null),r(c,ye),r(c,j),r(c,we),r(c,x),p(U,x,null),r(x,xe),r(x,q),r(c,Pe),r(c,P),p(z,P,null),r(P,De),r(P,B),r(c,Se),r(c,D),p(I,D,null),r(D,Fe),r(D,J),o(e,ce,a),p(V,e,a),o(e,de,a),o(e,X,a),me=!0},p:Ie,i(e){me||(f(F.$$.fragment,e),f(T.$$.fragment,e),f(C.$$.fragment,e),f(N.$$.fragment,e),f(k.$$.fragment,e),f(E.$$.fragment,e),f(L.$$.fragment,e),f(H.$$.fragment,e),f(M.$$.fragment,e),f(U.$$.fragment,e),f(z.$$.fragment,e),f(I.$$.fragment,e),f(V.$$.fragment,e),me=!0)},o(e){_(F.$$.fragment,e),_(T.$$.fragment,e),_(C.$$.fragment,e),_(N.$$.fragment,e),_(k.$$.fragment,e),_(E.$$.fragment,e),_(L.$$.fragment,e),_(H.$$.fragment,e),_(M.$$.fragment,e),_(U.$$.fragment,e),_(z.$$.fragment,e),_(I.$$.fragment,e),_(V.$$.fragment,e),me=!1},d(e){e&&(t(Z),t(Q),t(ee),t(te),t(ae),t(b),t(ne),t(le),t(v),t(re),t(ie),t(u),t(se),t(oe),t(c),t(ce),t(de),t(X)),t($),g(F,e),g(T,e),g(C),g(N,e),g(k),g(E,e),g(L),g(H,e),g(M),g(U),g(z),g(I),g(V,e)}}}const je='{"title":"Fully Sharded Data Parallel utilities","local":"fully-sharded-data-parallel-utilities","sections":[{"title":"enable_fsdp_ram_efficient_loading","local":"accelerate.utils.enable_fsdp_ram_efficient_loading","sections":[],"depth":2},{"title":"disable_fsdp_ram_efficient_loading","local":"accelerate.utils.disable_fsdp_ram_efficient_loading","sections":[],"depth":2},{"title":"merge_fsdp_weights","local":"accelerate.utils.merge_fsdp_weights","sections":[],"depth":2},{"title":"FullyShardedDataParallelPlugin","local":"accelerate.FullyShardedDataParallelPlugin","sections":[],"depth":2}],"depth":1}';function qe(Te){return Ve(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Xe extends Ae{constructor($){super(),Oe(this,$,qe,Ge,ze,{})}}export{Xe as component};
